"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _visitors = require("./visitors");

var _util = require("./util");

const plugin = () => ({
  manipulateOptions: (opts, parserOptions) => {
    parserOptions.plugins.push('classProperties');
    parserOptions.plugins.push('jsx');
    parserOptions.plugins.push('objectRestSpread');
  },

  pre() {
    this.store = new _util.Store();
  },

  visitor: {
    Program(programPath, {
      opts
    }) {
      programPath.traverse(_visitors.importVisitor, this.store);
      if (!this.store.hasImport) return;
      programPath.traverse(_visitors.entryVisitor, this.store);
      programPath.traverse(_visitors.propVisitor, this.store);
      (0, _util.appendProps)(this.store.getEntries(), opts);
    }

  }
});

var _default = plugin;
exports.default = _default;