"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClassProperty = exports.createFunctionProperty = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const createEntriesArray = props => {
  const entries = _lodash.default.uniq(props).sort().map(prop => t.stringLiteral(prop));

  return t.arrayExpression(entries);
};

const createFunctionProperty = (identifier, props) => {
  const left = t.memberExpression(t.identifier(identifier), t.identifier('handledProps'));
  const right = createEntriesArray(props);
  return t.expressionStatement(t.assignmentExpression('=', left, right));
};

exports.createFunctionProperty = createFunctionProperty;

const createClassProperty = props => {
  const key = t.identifier('handledProps');
  const value = createEntriesArray(props);
  const property = t.classProperty(key, value);
  property.static = true;
  return property;
};

exports.createClassProperty = createClassProperty;