"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.isClass = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const containsJSX = path => {
  if (t.isJSXElement(path)) return true;
  let containJSX;
  path.traverse({
    JSXElement(jsxPath) {
      containJSX = true;
      jsxPath.stop();
    }

  });
  return containJSX;
};

const isRenderMethod = member => t.isClassMethod(member) && t.isIdentifier(member.key, {
  name: 'render'
});

const hasRenderMethod = path => _lodash.default.get(path, 'node.body.body').some(isRenderMethod);

const hasSuperClass = ({
  node: {
    superClass
  }
}) => !!superClass;

const isClass = path => t.isClassDeclaration(path) || t.isClassExpression(path);

exports.isClass = isClass;

const isFunction = path => {
  if (t.isFunctionDeclaration(path)) return true;
  if (!t.isArrowFunctionExpression(path) && !t.isFunctionExpression(path)) return false;
  return t.isVariableDeclarator(path.parent);
};

const isReactClass = path => isClass(path) && hasSuperClass(path) && hasRenderMethod(path);

const isReactFunction = path => isFunction(path) && containsJSX(path.get('body'));

const isReactComponent = path => isReactClass(path) || isReactFunction(path);

var _default = isReactComponent;
exports.default = _default;